local regulargliding
local isTails = function(skin)
	return skin == "running_tails"
end
local isFollowMobjChar = function(skin)
	return (skin == "running_msonic"
		 or skin == "running_tails")
end

local multiplier = 1
local mobjscale = 1 -- default value

//start map check

local function getmapid(n)
    if n<100 then
        return (n<10) and ("0"..n) or tostring(n)
    end

    local x= n-100
    local p= x/36
    local q= x-(36*p)
    local a= string.char(string.byte('A')+p)
    local b= (q<10) and tostring(q) or string.char(string.byte('A')+q-10)

    return a..b
end

local function onLevelLoad()
    local map = mapheaderinfo[gamemap]
    if map and map.lvlttl then
        mobjscale = map.mobj_scale -- update the global variable

        -- Check if mobjscale is a factor of 65536
        while 65536 % mobjscale ~= 0 do
            mobjscale = mobjscale - 1
        end

        multiplier = 65536/mobjscale
    end
end
addHook("MapLoad", onLevelLoad)

//Code for Tails's tails used from SMS Alfredo's SRB2 Chars 

//Followmobj
freeslot("MT_RCHAROVERLAY", "S_RMETALJETFUMEFLASH", "S_RMETALJETFUME1")
for i = 0, 9
	freeslot("SPR_TAL"..i)
end
mobjinfo[MT_RCHAROVERLAY] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	seestate = S_RMETALJETFUMEFLASH,
	raisestate = S_RMETALJETFUME1,
	spawnhealth = 1000,
	reactiontime = 8,
	speed = 8,
	mass = 16,
	radius = 8*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY|MF_DONTENCOREMAP,
}
addHook("MobjThinker", function(mobj)
	if not (mobj.target and mobj.target.valid
	and isFollowMobjChar(mobj.target.skin)
	and mobj.target.player and mobj.target.player.rcharfollowmobj == mobj)
		P_KillMobj(mobj)
	else
		mobj.skin = mobj.target.skin
		A_CapeChase(mobj,0,0)
	end
end, MT_RCHAROVERLAY)

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "running_tails"
					and P_IsObjectOnGround(player.mo) or player.trickactive or player.hastricked)
		if player.sprung == nil
			player.sprung = false
		end
					player.sprung = false
					end
				end
			end)	

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "running_tails" and player.mo.paragliding and not (player.trickactive or player.hastricked))
		regulargliding = true
					else
						regulargliding = false
					end
				end
			end)
//Tails' tails
local P_DoRTailsOverlay = function(player, tails)
	// init...
	local horizangle = tails.angle
	local zoffs = 0
	local backwards = -3*FRACUNIT
	local chosensprite = 0
	local rollangle
	local Lost = player.exiting and K_IsPlayerLosing(player)
	// initial position...
	if ((player.kartstuff[k_dropdash] > 0 or player.kartstuff[k_respawn] > 0 or player.trickactive or player.hastricked or player.mo.momz > 0 and player.mo.momz < 250000) and not (P_IsObjectOnGround(player.mo) or player.kartstuff[k_spinouttimer] > 0 or (player.powers[pw_nocontrol] and player.pflags & PF_SKIDDOWN) or player.pflags & PF_SLIDING or regulargliding == true or player.trickstun))
		local testval, zdist
		if (player.speed < FRACUNIT)
			testval = FRACUNIT
		else
			testval = (FixedMul(player.speed, cos(horizangle - R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy))))
			if (testval < FRACUNIT)
				testval = FRACUNIT
			end
		end
	if ((player.kartstuff[k_dropdash] > 0 or player.kartstuff[k_respawn] > 0 or player.trickactive or player.hastricked or player.mo.momz > 0 and player.mo.momz < 250000) and not (P_IsObjectOnGround(player.mo) or player.kartstuff[k_spinouttimer] > 0 or (player.powers[pw_nocontrol] and player.pflags & PF_SKIDDOWN) or player.pflags & PF_SLIDING or regulargliding == true or player.trickstun))
			zdist = player.mo.momz<<1
			backwards = -7*FRACUNIT
		elseif (P_IsObjectOnGround(player.mo) and not player.mo.reactiontime)
			zdist = (player.mo.z - tails.threshold)
		else
			zdist = player.mo.momz
		end

		rollangle = R_PointToAngle2(0, 0, testval, -P_MobjFlip(player.mo)*zdist)

		if not P_IsObjectOnGround(player.mo)
			zoffs = 3*FRACUNIT + 12*sin(rollangle)
			backwards = -7*FRACUNIT
		end
	elseif regulargliding == true
		backwards = -10*FRACUNIT		
		zoffs = -20*FRACUNIT
	elseif (player.speed == 0 and not (player.kartstuff[k_boostcharge]) and P_IsObjectOnGround(player.mo)) //stand
		backwards = -1*FRACUNIT

	elseif (player.speed > player.mo.scale * 33 and not player.kartstuff[k_drift] and not (player.kartstuff[k_boostcharge]) and not player.kartstuff[k_spinouttimer] and not player.kartstuff[k_squishedtimer] and P_IsObjectOnGround(player.mo)) //run
		backwards = -8*FRACUNIT

	elseif (player.speed < player.mo.scale * 33 and multiplier == 2 and not player.kartstuff[k_drift] and not (player.kartstuff[k_boostcharge]) and not player.kartstuff[k_spinouttimer] and not player.kartstuff[k_squishedtimer] and P_IsObjectOnGround(player.mo)) //walk
		backwards = -5*FRACUNIT
	elseif (player.speed < player.mo.scale * 33 and multiplier == 1 and not player.kartstuff[k_drift] and not (player.kartstuff[k_boostcharge]) and not player.kartstuff[k_spinouttimer] and not player.kartstuff[k_squishedtimer] and P_IsObjectOnGround(player.mo)) //walk
		backwards = -2*FRACUNIT*multiplier

	elseif ((player.kartstuff[k_spinouttimer] > 0) or (player.powers[pw_nocontrol] and player.pflags & PF_SKIDDOWN) or player.pflags & PF_SLIDING) //pain
		//backwards = $ / 16

	elseif (player.kartstuff[k_drift] and P_IsObjectOnGround(player.mo) and not player.kartstuff[k_spinouttimer] and not player.kartstuff[k_squishedtimer] or player.kartstuff[k_boostcharge]) //spindash
		zoffs = -7*FRACUNIT
		backwards = -9*FRACUNIT	
	elseif not P_IsObjectOnGround(player.mo) and player.mo.momz >= 250000
		backwards = -3*FRACUNIT		
		zoffs = 7*FRACUNIT
	elseif not P_IsObjectOnGround(player.mo) and player.mo.momz <= 0
		backwards = -3*FRACUNIT		
		zoffs = 4*FRACUNIT
	end


	// sprite...
	if ((player.kartstuff[k_dropdash] > 0 or player.kartstuff[k_respawn] > 0 or player.trickactive or player.hastricked or player.mo.momz > 0 and player.mo.momz < 250000) and not (P_IsObjectOnGround(player.mo) or player.kartstuff[k_spinouttimer] > 0 or (player.powers[pw_nocontrol] and player.pflags & PF_SKIDDOWN) or player.pflags & PF_SLIDING or regulargliding == true or player.trickstun))
		local add = ((rollangle < 0) and 2 or 0)
		if (add)
			rollangle = InvAngle(rollangle)
		end
		rollangle = $ + ANG15 // modify the thresholds to be nice clean numbers
		if (rollangle > ANG60 or rollangle < 0) 
			chosensprite = SPR_TAL3 + add
		elseif (rollangle > ANG30 or rollangle < 0)
			chosensprite = SPR_TAL2 + add
		else
			chosensprite = SPR_TAL1
		end
	elseif (player.speed > player.mo.scale * 33 and not player.kartstuff[k_drift] and not player.kartstuff[k_spinouttimer] and not player.trickstun and not player.kartstuff[k_boostcharge] and not player.kartstuff[k_squishedtimer] and P_IsObjectOnGround(player.mo)) //run
		chosensprite = SPR_TAL6
	elseif (player.kartstuff[k_drift] and P_IsObjectOnGround(player.mo) or (player.kartstuff[k_boostcharge]))//Spindash
		chosensprite = SPR_TAL2
	elseif (player.speed <= player.mo.scale * 33 and player.speed > player.mo.scale * 0 and not player.kartstuff[k_drift] and not player.kartstuff[k_spinouttimer] and not player.kartstuff[k_squishedtimer] and not (player.kartstuff[k_boostcharge]) and not player.trickstun and P_IsObjectOnGround(player.mo)) //walk
		if smilesonground
			chosensprite = SPR_TAL2
		elseif (player.speed >= 18*player.mo.scale)
			chosensprite = SPR_TAL1
		else
			chosensprite = SPR_TAL4
		end
	elseif player.speed == 0 and not player.kartstuff[k_spinouttimer] and not player.kartstuff[k_squishedtimer] and P_IsObjectOnGround(player.mo) and not Lost //stand
		chosensprite = SPR_TAL0
	elseif player.mo.momz >= 250000 and not (player.trickstun or (player.kartstuff[k_spinouttimer] > 0) or (player.powers[pw_nocontrol] and player.pflags & PF_SKIDDOWN) or player.pflags & PF_SLIDING)
		chosensprite = SPR_TAL5
	elseif player.mo.momz <= 0 and not (player.trickstun or (player.kartstuff[k_spinouttimer] > 0) or (player.powers[pw_nocontrol] and player.pflags & PF_SKIDDOWN) or player.pflags & PF_SLIDING)
		chosensprite = SPR_TAL3
	elseif regulargliding == true and not (player.trickstun or (player.kartstuff[k_spinouttimer] > 0) or (player.powers[pw_nocontrol] and player.pflags & PF_SKIDDOWN) or player.pflags & PF_SLIDING)
		chosensprite = SPR_TAL3
	end
	
	// state and animation...
	tails.state = S_INVISIBLE
	tails.sprite = chosensprite
	//Stand
	if chosensprite == SPR_TAL0
		tails.frame = (leveltime%30)/5
	//Walk/Roll/Swim
	elseif chosensprite >= SPR_TAL1 and chosensprite <= SPR_TAL5
		if(player.speed <= player.mo.scale * 33 and not player.kartstuff[k_drift] and not player.kartstuff[k_spinouttimer] and not player.kartstuff[k_squishedtimer] and P_IsObjectOnGround(player.mo)) //walk
			tails.frame = (leveltime%16)/2
		elseif player.speed > 16*player.mo.scale or player.fly1
			tails.frame = leveltime%8
		else
			tails.frame = (leveltime%16)/2
		end
	//Run
	elseif chosensprite == SPR_TAL6
		if player.speed > 43*player.mo.scale
			tails.frame = leveltime%4
		else
			tails.frame = (leveltime%8)/2
		end
	//Spring
	elseif chosensprite == SPR_TAL5 and player.sprung == true
		tails.frame = leveltime%8
	elseif chosensprite == SPR_TAL3 and player.sprung == true
		tails.frame = leveltime%8
	//Pain
	elseif chosensprite == SPR_TAL9
		tails.frame = 0
	end

	// final handling...
	tails.color = player.mo.color
	tails.colorized = player.mo.colorized
	tails.threshold = player.mo.z
	tails.angle = player.frameangle
	P_SetScale(tails, player.mo.scale)
	tails.destscale = player.mo.destscale
	tails.radius = player.mo.radius
	tails.height = player.mo.height
	zoffs = FixedMul(zoffs, tails.scale)

	if (player.mo.eflags & MFE_VERTICALFLIP)
		tails.eflags = $ | MFE_VERTICALFLIP
		tails.flags2 = $ | MF2_OBJECTFLIP
		zoffs = player.mo.height - tails.height - zoffs
	else
		tails.eflags = $ & ~MFE_VERTICALFLIP
		tails.flags2 = $ & ~MF2_OBJECTFLIP
	end
	
	K_MatchGenericExtraFlags(tails, player.mo)

	P_TeleportMove(tails,
	player.mo.x + P_ReturnThrustX(tails, tails.angle, FixedMul(backwards, tails.scale)),
	player.mo.y + P_ReturnThrustY(tails, tails.angle, FixedMul(backwards, tails.scale)),
	player.mo.z + zoffs)
end


//Reset the variables
//Using a custom spinning variable since Kart uses PF_SPINNING for other purposes
addHook("PlayerSpawn", function(player)
	player.waittimer = 3*TICRATE+#player
	player.srb2hit = false
	player.rcharfollowmobj = nil
	player.srb2frameangle = player.frameangle
end)

//It feels wrong using ThinkFrame instead of PlayerThink now
addHook("ThinkFrame", do

for player in players.iterate
	if player.mo and player.mo.valid and isTails(player.mo.skin)
	and not (player.kartstuff[k_comebacktimer] <= 0
	and player.kartstuff[k_bumper] <= 0 and G_BattleGametype())
		player.mo.radius = 23*player.mo.scale/2
		player.kartstuff[k_enginesnd] = 0
		player.pflags = $&~PF_SKIDDOWN
		//Stop the engine sound

		
		//Determine if we're Tails
		local runningtails = player.mo.skin == "running_tails"

			//Followmobj
			if (runningtails) and player.mo.health
				if player.rcharfollowmobj and player.rcharfollowmobj.valid
					if player.rcharfollowmobj.type != MT_RCHAROVERLAY
						player.rcharfollowmobj = nil
					elseif player.rcharfollowmobj.target != player.mo
						P_KillMobj(player.rcharfollowmobj)
						player.rcharfollowmobj = nil
					else
						P_DoRTailsOverlay(player, player.rcharfollowmobj)
					end
				else
					player.rcharfollowmobj = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_RCHAROVERLAY)
					player.rcharfollowmobj.target = player.mo
				end
			end
			continue
		end
		player.srb2hit = false
		player.srb2hitter = nil
		
		//Followmobj
		if (runningtails) and player.mo.health
			if player.rcharfollowmobj and player.rcharfollowmobj.valid
				if player.rcharfollowmobj.type != MT_RCHAROVERLAY
					player.rcharfollowmobj = nil
				elseif player.rcharfollowmobj.target != player.mo
					P_KillMobj(player.rcharfollowmobj)
					player.rcharfollowmobj = nil
				else
					P_DoRTailsOverlay(player, player.rcharfollowmobj)
				end
			else
				player.rcharfollowmobj = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_RCHAROVERLAY)
				player.rcharfollowmobj.target = player.mo
			end
		end
end end)

addHook("MobjMoveCollide", function(mobj, spring)
	if (spring.flags & MF_SPRING) 
		if (mobj.z <= spring.z + spring.height)
		and (spring.z <= mobj.z + mobj.height)
		and (mobj.skin == "running_tails")
		and not mobj.player.powers[pw_super]
			mobj.player.sprung = true
		end
	end
	if (spring.type == MT_SPRINGSHELL and spring.health > 0) then
		local tmz = (spring.eflags & MFE_VERTICALFLIP and -((mobj.z + mobj.height) or 1) or mobj.z)
		local tmznext = (spring.eflags & MFE_VERTICALFLIP and -mobj.momz or mobj.momz) + tmz
		local thzh = (spring.eflags & MFE_VERTICALFLIP and -(spring.z or 1) or spring.z + spring.height)
		local sprarea = FixedMul(8*FRACUNIT, spring.scale) * P_MobjFlip(spring)
		if (((tmznext <= thzh) and (tmz > thzh)) or ((tmznext > thzh - sprarea) and (tmznext < thzh))) then
			mobj.player.sprung = true
		end
	end
end, MT_PLAYER)
