addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "running_sonic"
					and P_IsObjectOnGround(player.mo)
		if player.sprung == nil
			player.sprung = false
		end
					player.sprung = false
					end
				end
			end)

addHook("MobjMoveCollide", function(mobj, spring)
	if (spring.flags & MF_SPRING) 
		if (mobj.z <= spring.z + spring.height)
		and (spring.z <= mobj.z + mobj.height)
		and (mobj.skin == "running_sonic")
		and not mobj.player.powers[pw_super]
			mobj.player.sprung = true
		end
	end
	if (spring.type == MT_SPRINGSHELL and spring.health > 0) then
		local tmz = (spring.eflags & MFE_VERTICALFLIP and -((mobj.z + mobj.height) or 1) or mobj.z)
		local tmznext = (spring.eflags & MFE_VERTICALFLIP and -mobj.momz or mobj.momz) + tmz
		local thzh = (spring.eflags & MFE_VERTICALFLIP and -(spring.z or 1) or spring.z + spring.height)
		local sprarea = FixedMul(8*FRACUNIT, spring.scale) * P_MobjFlip(spring)
		if (((tmznext <= thzh) and (tmz > thzh)) or ((tmznext > thzh - sprarea) and (tmznext < thzh))) then
			mobj.player.sprung = true
		end
	end
end, MT_PLAYER)

SIMPLE_ANIMAL_DEFINITIONS["running_sonic"] = {
	--Base animations--
  ["goal"] = {H},
--[TRICK_BEHIND] = {A-E}, -- Acrobatics plays "A-E" as the rotations for afterimages that play after you've tricked so I'm gonna leave them blank.
--[CHARACTER_SELECT] = {G}, -- G and J get used for the character select animation.  
  ["stand"] = {J},
  ["walk"] = {K, L, M, N, O, P, Q, R},
  ["run"] = {S, T, U, V},
  ["reverse"] = {R, Q, P, O, N, M, L, K},
  ["trick"] = {Z+33, Z+34, Z+35, Z+36},
  ["spin"] = {I},
  ["pain"] = {Z+9},
  ["squish"] = {Z+8},
  ["ascend"] = {Z+5},
  ["descend"] = {Z+6, Z+6, Z+7, Z+7},
  ["glide"] = {F},  
  ["finished"] = {J},
  ["drift"] = {Z+1, Z+2, Z+3, Z+4},
------------------------------------------------------------------------------------------------------------------
  ["sonicwalk"] = {K, L, M, N, O, P, Q, R},   
  ["sonicrun"] = {S, S, T, T, U, U, V, V},
  ["fastrun"] = {S, T, U, V},
  ["roll"] = {W, X, Z+33, Y, Z, Z+33},
  ["superglide"] = {Z+10},
  ["superspin"] = {Z+11},
  ["superstand"] = {Z+12, Z+12, Z+13, Z+13, Z+14, Z+14, Z+15, Z+15},
  ["superwalk"] = {Z+16, Z+17, Z+18, Z+19, Z+20, Z+21, Z+22, Z+23},
  ["superreverse"] = {Z+23, Z+22, Z+21, Z+20, Z+19, Z+18, Z+17, Z+16},
  ["superrun"] = {Z+24, Z+24, Z+25, Z+25},
  ["superascend"] = {Z+26}, 
  ["superdescend"] = {Z+27, Z+27, Z+28, Z+28},
  ["win"] = {Z+29, Z+29, Z+29, Z+29, Z+29, Z+29, Z+29, Z+29, Z+29, Z+29, Z+29, Z+29, Z+29, Z+29, Z+29, Z+29,
             Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30},
  ["lose"] = {Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31,
			  Z+32, Z+32, Z+32, Z+32, Z+32, Z+32, Z+32, Z+32, Z+32, Z+32, Z+32, Z+32, Z+32, Z+32, Z+32, Z+32},
}
			--Character Specific--

function SIMPLE_ANIMAL_HELPERS.isSonicRunSpeed(mobj) -- Checks if the player is at Sonic's running speed.
  local player = SIMPLE_ANIMAL_HELPERS.getPlayer(mobj)
  return player.speed > mobj.scale * 37 and player.speed <= mobj.scale * 48
end

function SIMPLE_ANIMAL_HELPERS.isSonicTopSpeed(mobj) -- Checks if the player is at Sonic's top speed.
  return SIMPLE_ANIMAL_HELPERS.getPlayer(mobj).speed > mobj.scale * 48
end

function SIMPLE_ANIMAL_HELPERS.isSonicWalkSpeed(mobj) -- Checks if the player is at Sonic's walking speed, but not running speed.
  local player = SIMPLE_ANIMAL_HELPERS.getPlayer(mobj)
  return player.speed > 0 and player.speed <= mobj.scale * 37
end

function SIMPLE_ANIMAL_HELPERS.isSonicWalkSpeedMultiplied(mobj, fixed_multiplier) -- Checks if the player's speed is >= Sonic's walking speed multiplied (using fixed-point math.)
  local run = (mobj.scale * 48)
  return SIMPLE_ANIMAL_HELPERS.getPlayer(mobj).speed >= FixedMul(run, fixed_multiplier)
end

			--Other added helpers--

function SIMPLE_ANIMAL_HELPERS.isGliding(mobj)
  return mobj.paragliding
end

function SIMPLE_ANIMAL_HELPERS.isGrinding(mobj) -- Checks if the player is on grind rail.
  local player = SIMPLE_ANIMAL_HELPERS.getPlayer(mobj)
  return (player.grinding)
end

function SIMPLE_ANIMAL_HELPERS.isSpinDashing(mobj) -- Checks if the player is spindashing.
  local player = SIMPLE_ANIMAL_HELPERS.getPlayer(mobj)
  return player.spindash and player.spindash.active
end

function SIMPLE_ANIMAL_HELPERS.isScending(mobj) -- Checks if the player is nor rising or falling through the air.
  return mobj.momz > 0 and mobj.momz < 250000 and not P_IsObjectOnGround(mobj)
end

function SIMPLE_ANIMAL_HELPERS.isSuper(mobj) -- Checks if the player is super.
  return SIMPLE_ANIMAL_HELPERS.getPlayer(mobj).masteremerald.super
end

function SIMPLE_ANIMAL_HELPERS.isLose(mobj) -- Checks if the player is losing.
  local player = SIMPLE_ANIMAL_HELPERS.getPlayer(mobj)
  if player then
    return K_IsPlayerLosing(player)
  else
    return false
  end
end

function SIMPLE_ANIMAL_HELPERS.isWin(mobj) -- Checks if the player is winning.
  local player = SIMPLE_ANIMAL_HELPERS.getPlayer(mobj)
  if player then
    return not K_IsPlayerLosing(player)
  else
    return false
  end
end

function SIMPLE_ANIMAL_HELPERS.isSpringingDown(mobj) -- Checks if the player is falling through the air after bouncing off a spring.
  local player = SIMPLE_ANIMAL_HELPERS.getPlayer(mobj)
  return mobj.momz <= 0 and not P_IsObjectOnGround(mobj) and player.sprung == true
end

-- the regular isSpringing function is for spring pads or the pogospring item

function SIMPLE_ANIMAL_HELPERS.isSpringingUp(mobj) -- Checks if the player is falling through the air after bouncing off a spring.
  local player = SIMPLE_ANIMAL_HELPERS.getPlayer(mobj)
  return mobj.momz >= 0 and player.sprung == true
end
				--Rest of Code--

function SIMPLE_ANIMAL_HOOKS.running_sonic_hook(mobj, sequences)
  if mobj.skin == "running_sonic"
    local helpers = _G["SIMPLE_ANIMAL_HELPERS"]
	
	  local halfspeed = helpers.isSonicWalkSpeedMultiplied(mobj, FRACUNIT/2)
	  local quarterspeed = helpers.isSonicWalkSpeedMultiplied(mobj, FRACUNIT/4)
    if (sequences[1] == "goal")
      return
	elseif helpers.isSquished(mobj)
	  return "squish"
	elseif helpers.isPained(mobj)
	  return "pain"
	elseif helpers.isSpinning(mobj) and helpers.isInvincible(mobj)
	  return "superspin"
	elseif helpers.isSpinning(mobj)
	  return "spin"
	elseif (helpers.isTricking(mobj) or helpers.isDropDashing(mobj) or helpers.isRespawning(mobj))
	  return "trick"
	elseif helpers.isGliding(mobj) and helpers.isInvincible(mobj)
	  return "superglide"
	elseif helpers.isGliding(mobj)
	  return "glide"
	elseif (helpers.isGrinding(mobj) or helpers.isScending(mobj))
	  return "roll"
    elseif helpers.isAscending(mobj) and helpers.isInvincible(mobj)
      return "superascend"
    elseif helpers.isAscending(mobj)
      return "ascend"
    elseif helpers.isDescending(mobj) and helpers.isInvincible(mobj)
      return "superdescend"
    elseif helpers.isDescending(mobj)
      return "descend"
	elseif (helpers.isCountdownCharging(mobj) or helpers.isDriftingLeft(mobj) or helpers.isDriftingRight(mobj))
      return "drift"
	elseif (helpers.isSonicRunSpeed(mobj) or helpers.isSonicTopSpeed(mobj)) and helpers.isInvincible(mobj)
	  return "superrun"
	elseif helpers.isSonicTopSpeed(mobj)
	  return "fastrun"
	elseif helpers.isSonicRunSpeed(mobj)
	  return "sonicrun"
	elseif helpers.isNoSpeed(mobj) and helpers.isInvincible(mobj)
	  return "superstand"
    elseif helpers.isFinished(mobj) and helpers.isNoSpeed(mobj)
		if helpers.isLose(mobj)
      return "lose"
		elseif helpers.isWin(mobj)
	  return "win"
		else
	  return "stand"
		end
elseif helpers.isSonicWalkSpeed(mobj) and helpers.isInvincible(mobj)then
    if helpers.isMovingForward(mobj) then
        if ((not quarterspeed and leveltime % 4 < 3) or (quarterspeed and not halfspeed) and leveltime % 2 < 1) then
            mobj.Simple_AnimaL_timer = mobj.Simple_AnimaL_timer - 1
        end
        return "superwalk"
    elseif helpers.isMovingBackward(mobj) then
        if ((not quarterspeed and leveltime % 4 < 3) or (quarterspeed and not halfspeed) and leveltime % 2 < 1) then
            mobj.Simple_AnimaL_timer = mobj.Simple_AnimaL_timer - 1
        end
        return "superreverse"
    end

elseif helpers.isSonicWalkSpeed(mobj)then
    if helpers.isMovingForward(mobj) then
        if ((not quarterspeed and leveltime % 4 < 3) or (quarterspeed and not halfspeed) and leveltime % 2 < 1) then
            mobj.Simple_AnimaL_timer = mobj.Simple_AnimaL_timer - 1
        end
        return "sonicwalk"
    elseif helpers.isMovingBackward(mobj) then
        if ((not quarterspeed and leveltime % 4 < 3) or (quarterspeed and not halfspeed) and leveltime % 2 < 1) then
            mobj.Simple_AnimaL_timer = mobj.Simple_AnimaL_timer - 1
        end
        return "reverse"
    end
	end
end
end